Lorene::Tslice_dirac_max Class Reference
Time evolution (<em><strong>under development</strong></em>)

Spacelike time slice of a 3+1 spacetime with conformal decomposition in the maximal slicing and Dirac gauge. More...

`#include <time_slice.h>`

Inheritance diagram for Lorene::Tslice_dirac_max:

## Public Member Functions

| Tslice_dirac_max (const Scalar &lapse_in, const Vector &shift_in, const Metric_flat &ff_in, const Scalar &psi_in, const Sym_tensor_trans &hh_in, const Sym_tensor &hata_in, int depth_in=3)
| Constructor from conformal decomposition.
| Tslice_dirac_max (const Map &mp, const Base_vect &triad, const Metric_flat &ff_in, int depth_in=3)
| Constructor as standard time slice of flat spacetime (Minkowski).
| Tslice_dirac_max (const Map &mp, const Base_vect &triad, const Metric_flat &ff_in, FILE *fich, bool partial_read, int depth_in=3)
| Constructor from binary file.
Construnction of a stationary slice from a rotating star | Tslice_dirac_max (const Star_rot_Dirac &star, double pdt, int depth_in=3)
| Tslice_dirac_max (const Tslice_dirac_max &)
| Copy constructor.
virtual | ~Tslice_dirac_max ()
| Destructor.
Assignment to another Tslice_dirac_max void | operator= (const Tslice_dirac_max &)
virtual void | set_hh (const Sym_tensor &hh_in)
| Sets the deviation of the conformal metric from the flat metric : .
virtual void | initial_data_cts (const Sym_tensor &uu, const Scalar &trk_in, const Scalar &trk_point, double pdt, double precis=1.e-12, int method_poisson_vect=6, const char *graph_device=0x0, const Scalar *ener_dens=0x0, const Vector *mom_dens=0x0, const Scalar *trace_stress=0x0)
| Computes valid initial data by solving the constraint equations in the conformal thin-sandwich approach.
virtual void | set_khi_mu (const Scalar &khi_in, const Scalar &mu_in)
| Sets the potentials and of the TT part of (see the documentation of `Sym_tensor_tt` for details).
virtual void | set_AB_hh (const Scalar &A_in, const Scalar &B_in)
| Sets the potentials A and of the TT part of (see the documentation of `Sym_tensor` for details).
virtual void | set_trh (const Scalar &trh_in)
| Sets the trace, with respect to the flat metric `ff` , of .
virtual Scalar | solve_psi (const Scalar *ener_dens=0x0) const
| Solves the elliptic equation for the conformal factor $\Psi$ (Hamiltonian constraint).
virtual Scalar | solve_npsi (const Scalar *ener_dens=0x0, const Scalar *trace_stress=0x0) const
| Solves the elliptic equation for (maximal slicing condition + Hamiltonian constraint).
virtual Vector | solve_beta (int method=6) const
| Solves the elliptic equation for the shift vector from (Eq.
void | evolve (double pdt, int nb_time_steps, int niter_elliptic, double relax_elliptic, int check_mod, int save_mod, int method_poisson_vect=6, int nopause=1, const char *graph_device=0x0, bool verbose=true, const Scalar *ener_euler=0x0, const Vector *mom_euler=0x0, const Scalar *s_euler=0x0, const Sym_tensor *strain_euler=0x0)
| Time evolution by resolution of Einstein equations.
virtual double | adm_mass () const
| Returns the ADM mass at (geometrical units) the current step.
virtual const Sym_tensor & | hh (Param *par_bc=0x0, Param *par_mat=0x0) const
| Deviation of the conformal metric from the flat metric : .
virtual const Scalar & | trk () const
| Trace K of the extrinsic curvature at the current time step (`jtime` ).
virtual const Vector & | hdirac () const
| Vector which vanishes in Dirac gauge.
virtual const Scalar & | A_hh () const
| Returns the potential A of .
virtual const Scalar & | B_hh () const
| Returns the potential of .
virtual const Scalar & | trh () const
| Computes the trace `h`, with respect to the flat metric `ff` , of .
virtual void | set_psi_del_npsi (const Scalar &psi_in)
| Sets the conformal factor relating the physical metric to the conformal one: .
virtual void | set_psi_del_n (const Scalar &psi_in)
| Sets the conformal factor relating the physical metric to the conformal one: .
virtual void | set_npsi_del_psi (const Scalar &npsi_in)
| Sets the factor at the current time step (`jtime` ) and deletes the value of .
virtual void | set_npsi_del_n (const Scalar &npsi_in)
| Sets the factor at the current time step (`jtime` ) and deletes the value of N.
virtual void | set_hata (const Sym_tensor &hata_in)
| Sets the conformal representation of the traceless part of the extrinsic curvature: .
virtual void | set_hata_TT (const Sym_tensor_tt &hata_tt)
| Sets the TT part of (see member `hata_evol` ).
virtual void | set_hata_from_XAB (Param *par_bc=0x0, Param *par_mat=0x0)
| Sets the conformal representation of the traceless part of the extrinsic curvature from its potentials A, and .
virtual const Scalar & | nn () const
| Lapse function N at the current time step (`jtime` ).
virtual const Sym_tensor & | gam_dd () const
| Induced metric (covariant components ) at the current time step (`jtime` ).
virtual const Sym_tensor & | gam_uu () const
| Induced metric (contravariant components ) at the current time step (`jtime` ).
virtual const Sym_tensor & | k_dd () const
| Extrinsic curvature tensor (covariant components ) at the current time step (`jtime` ).
virtual const Sym_tensor & | k_uu () const
| Extrinsic curvature tensor (contravariant components ) at the current time step (`jtime` ).
virtual const Scalar & | A_hata () const
| Returns the potential A of .
virtual const Scalar & | B_hata () const
| Returns the potential of .
virtual const Scalar & | psi () const
| Conformal factor relating the physical metric to the conformal one: .
const Scalar & | psi4 () const
| Factor at the current time step (`jtime` ).
const Scalar & | ln_psi () const
| Logarithm of at the current time step (`jtime` ).
virtual const Scalar & | npsi () const
| Factor at the current time step (`jtime` ).
virtual const Metric & | tgam () const
| Conformal metric Returns the value at the current time step (`jtime` ).
virtual const Sym_tensor & | hata () const
| Conformal representation of the traceless part of the extrinsic curvature: .
virtual Sym_tensor | aa () const
| Conformal representation of the traceless part of the extrinsic curvature: .
virtual const Vector & | vec_X (int method_poisson=6) const
| Vector representing the longitudinal part of .
void | compute_X_from_momentum_constraint (const Vector &hat_S, const Sym_tensor_tt &hata_tt, int iter_max=200, double precis=1.e-12, double relax=0.8, int methode_poisson=6)
| Computes the vector from the conformally-rescaled momentum , using the momentum constraint.
void | set_scheme_order (int ord)
| Sets the order of the finite-differences scheme.
int | get_scheme_order () const
| Gets the order of the finite-differences scheme.
int | get_latest_j () const
| Gets the latest value of time step index.
const Evolution_std< double > & | get_time () const
| Gets the time coordinate t at successive time steps.
virtual const Vector & | beta () const
| shift vector at the current time step (`jtime` )
const Metric & | gam () const
| Induced metric at the current time step (`jtime` ).
Tbl | check_hamiltonian_constraint (const Scalar *energy_density=0x0, ostream &ost=cout, bool verb=true) const
| Checks the level at which the hamiltonian constraint is verified.
Tbl | check_momentum_constraint (const Vector *momentum_density=0x0, ostream &ost=cout, bool verb=true) const
| Checks the level at which the momentum constraints are verified.
Tbl | check_dynamical_equations (const Sym_tensor *strain_tensor=0x0, const Scalar *energy_density=0x0, ostream &ost=cout, bool verb=true) const
| Checks the level at which the dynamical equations are verified.
void | save (const char *rootname) const
| Saves in a binary file.

## Protected Member Functions

void | compute_sources (const Sym_tensor *strain_tensor=0x0) const
| Computes the sources `source_A_XXX_evol` and `source_B_XXX_evol` , for the solution of the evolution equation for and .
Copy the sources c source_A_XXX_evol and c source_B_XXX_evol to all time steps void | initialize_sources_copy () const
void | hh_det_one (int j, Param *par_bc=0x0, Param *par_mat=0x0) const
| Computes from the values of A and and using the condition , which fixes the trace of .
void | hh_det_one (const Sym_tensor_tt &hijtt, Param *par_mat=0x0) const
| Computes from the TT part using the condition , which fixes the trace of .
| Operator (virtual function called by the operator<<). virtual ostream &operator>>(ostream &) const
virtual void | sauve (FILE *fich, bool partial_save) const
| Total or partial saves in a binary file.
virtual void | del_deriv () const
| Deletes all the derived quantities.
void | set_der_0x0 () const
| Sets to `0x0` all the pointers on derived quantities.
virtual ostream & | operator>> (ostream &) const
| Operator >> (virtual function called by the operator<<).

## Protected Attributes

Evolution_std< Scalar > | A_hh_evol
| The A potential of .
Evolution_std< Scalar > | B_hh_evol
| The potential of .
Evolution_std< Scalar > | source_A_hh_evol
| The A potential of the source of equation for .
Evolution_std< Scalar > | source_B_hh_evol
| The potential of the source of equation for .
Evolution_std< Scalar > | source_A_hata_evol
| The potential A of the source of equation for .
Evolution_std< Scalar > | source_B_hata_evol
| The potential of the source of equation for .
The | trace
The with respect to the flat metric c | ff
The with respect to the flat metric c of f$ | h
Evolution_std< Scalar > | psi_evol
| Values at successive time steps of the conformal factor relating the physical metric to the conformal one: .
Evolution_std< Scalar > | npsi_evol
| Values at successive time steps of the factor .
Evolution_std< Sym_tensor > | hh_evol
| Values at successive time steps of the components .
Evolution_std< Sym_tensor > | hata_evol
| Values at successive time steps of the components .
Evolution_std< Scalar > | A_hata_evol
| Potential A associated with the symmetric tensor .
Evolution_std< Scalar > | B_hata_evol
| Potential associated with the symmetric tensor .
Metric * | p_tgamma
| Pointer on the conformal metric at the current time step (`jtime`).
Scalar * | p_psi4
| Pointer on the factor at the current time step (`jtime`).
Scalar * | p_ln_psi
| Pointer on the logarithm of at the current time step (`jtime`).
Vector * | p_hdirac
| Pointer on the vector (which vanishes in Dirac gauge), at the current time step (`jtime`).
Vector * | p_vec_X
| Pointer on the vector representing the longitudinal part of .
int | depth
| Number of stored time slices.
int | scheme_order
| Order of the finite-differences scheme for the computation of time derivatives.
int | jtime
| Time step index of the latest slice.
Evolution_std< double > | the_time
| Time label of each slice.
Evolution_std< Sym_tensor > | gam_dd_evol
| Values at successive time steps of the covariant components of the induced metric .
Evolution_std< Sym_tensor > | gam_uu_evol
| Values at successive time steps of the contravariant components of the induced metric .
Evolution_std< Sym_tensor > | k_dd_evol
| Values at successive time steps of the covariant components of the extrinsic curvature tensor .
Evolution_std< Sym_tensor > | k_uu_evol
| Values at successive time steps of the contravariant components of the extrinsic curvature tensor .
Evolution_std< Scalar > | n_evol
| Values at successive time steps of the lapse function N.
Evolution_std< Vector > | beta_evol
| Values at successive time steps of the shift vector .
Evolution_std< Scalar > | trk_evol
| Values at successive time steps of the trace K of the extrinsic curvature.
Evolution_full< Tbl > | adm_mass_evol
| ADM mass at each time step, since the creation of the slice.
Metric * | p_gamma
| Pointer on the induced metric at the current time step (`jtime`).

## Detailed Description

Spacelike time slice of a 3+1 spacetime with conformal decomposition in the maximal slicing and Dirac gauge.

()

Definition at line 968 of file time_slice.h.

## Constructor & Destructor Documentation

## Tslice_dirac_max() [1/5]

Lorene::Tslice_dirac_max::Tslice_dirac_max | ( | const Scalar & | lapse_in,
|  | const Vector & | shift_in,
|  | const Metric_flat & | ff_in,
|  | const Scalar & | psi_in,
|  | const Sym_tensor_trans & | hh_in,
|  | const Sym_tensor & | hata_in,
|  | int | depth_in = 3 )

Constructor from conformal decomposition.

Parameters

  lapse_in | lapse function N
  shift_in | shift vector
  ff_in | reference flat metric with respect to which the conformal decomposition is performed
  psi_in | conformal factor relating the physical metric to the conformal one:
  hh_in | deviation of the conformal metric from the flat metric : . must be such that .
  hata_in | conformal representation of the traceless part of the extrinsic curvature: , with K = 0 in the present case
  depth_in | number of stored time slices; this parameter is used to set the `scheme_order` member with `scheme_order` = `depth_in` - 1. `scheme_order` can be changed afterwards by the method `set_scheme_order(int)`.

Definition at line 149 of file tslice_dirac_max.C.

References A_hh_evol, B_hh_evol, source_A_hata_evol, source_A_hh_evol, source_B_hata_evol, source_B_hh_evol, and Lorene::Time_slice_conf::Time_slice_conf().

## Tslice_dirac_max() [2/5]

Lorene::Tslice_dirac_max::Tslice_dirac_max | ( | const Map & | mp,
|  | const Base_vect & | triad,
|  | const Metric_flat & | ff_in,
|  | int | depth_in = 3 )

Constructor as standard time slice of flat spacetime (Minkowski).

Parameters

  mp | Mapping on which the various Lorene fields will be constructed
  triad | vector basis with respect to which the various tensor components will be defined
  ff_in | reference flat metric with respect to which the conformal decomposition is performed
  depth_in | number of stored time slices; this parameter is used to set the `scheme_order` member with `scheme_order` = `depth_in` - 1. `scheme_order` can be changed afterwards by the method `set_scheme_order(int)`.

Definition at line 163 of file tslice_dirac_max.C.

References A_hh_evol, B_hh_evol, Lorene::Time_slice::jtime, Lorene::Map(), Lorene::Scalar::set_etat_zero(), source_A_hata_evol, source_A_hh_evol, source_B_hata_evol, source_B_hh_evol, Lorene::Time_slice::the_time, and Lorene::Time_slice_conf::Time_slice_conf().

## Tslice_dirac_max() [3/5]

Lorene::Tslice_dirac_max::Tslice_dirac_max | ( | const Map & | mp,
|  | const Base_vect & | triad,
|  | const Metric_flat & | ff_in,
|  | FILE * | fich,
|  | bool | partial_read,
|  | int | depth_in = 3 )

Constructor from binary file.

The binary file must have been created by method `save`.

Parameters

  mp | Mapping on which the various Lorene fields will be constructed
  triad | vector basis with respect to which the various tensor components will be defined
  ff_in | reference flat metric with respect to which the conformal decomposition is performed
  fich | file containing the saved `Tslice_dirac_max`
  partial_read | indicates whether the full object must be read in file or whether the final construction is devoted to a constructor of a derived class
  depth_in | number of stored time slices; the given must coincide with that stored in the file.

Definition at line 193 of file tslice_dirac_max.C.

References A_hh_evol, B_hh_evol, Lorene::Time_slice::depth, Lorene::fread_be(), Lorene::Time_slice_conf::hh_evol, Lorene::Time_slice::jtime, Lorene::Map(), source_A_hata_evol, source_A_hh_evol, source_B_hata_evol, source_B_hh_evol, Lorene::Time_slice::the_time, and Lorene::Time_slice_conf::Time_slice_conf().

## Tslice_dirac_max() [4/5]

Lorene::Tslice_dirac_max::Tslice_dirac_max | ( | const Star_rot_Dirac & | star,
|  | double | pdt,
|  | int | depth_in = 3 )

Definition at line 247 of file tslice_dirac_max.C.

## Tslice_dirac_max() [5/5]

Lorene::Tslice_dirac_max::Tslice_dirac_max | ( | const Tslice_dirac_max & | tin | ) |

Copy constructor.

Definition at line 299 of file tslice_dirac_max.C.

References A_hh_evol, B_hh_evol, source_A_hata_evol, source_A_hh_evol, source_B_hata_evol, source_B_hh_evol, Lorene::Time_slice_conf::Time_slice_conf(), and Tslice_dirac_max().

## ~Tslice_dirac_max()

Lorene::Tslice_dirac_max::~Tslice_dirac_max | ( |  | ) |

virtual

Destructor.

Definition at line 314 of file tslice_dirac_max.C.

## Member Function Documentation

## A_hata()

const Scalar & Lorene::Time_slice_conf::A_hata | ( |  | ) | const

virtual inherited

Returns the potential A of .

See the documentation of `Sym_tensor` for details. Returns the value at the current time step (`jtime` ).

Definition at line 664 of file time_slice_conf.C.

References A_hata_evol, Lorene::Scalar::dec_dzpuis(), Lorene::Scalar::get_dzpuis(), hata_evol, Lorene::Time_slice::jtime, and Lorene::Time_slice::the_time.

## A_hh()

const Scalar & Lorene::Tslice_dirac_max::A_hh | ( |  | ) | const

virtual

Returns the potential A of .

See the documentation of `Sym_tensor` for details. Returns the value at the current time step (`jtime` ).

Definition at line 525 of file tslice_dirac_max.C.

References A_hh_evol, Lorene::Time_slice_conf::hh_evol, Lorene::Time_slice::jtime, and Lorene::Time_slice::the_time.

## aa()

Sym_tensor Lorene::Time_slice_conf::aa | ( |  | ) | const

virtual inherited

Conformal representation of the traceless part of the extrinsic curvature: .

Returns the value at the current time step (`jtime` ).

Definition at line 765 of file time_slice_conf.C.

References hata(), psi(), and psi4().

## adm_mass()

double Lorene::Tslice_dirac_max::adm_mass | ( |  | ) | const

virtual

Returns the ADM mass at (geometrical units) the current step.

Moreover this method updates `adm_mass_evol` if necessary.

Reimplemented from Lorene::Time_slice.

Definition at line 143 of file tslice_adm_mass.C.

References Lorene::Time_slice::adm_mass_evol, Lorene::Scalar::derive_con(), Lorene::Vector::flux(), Lorene::Tensor::get_mp(), Lorene::Tbl::get_taille(), hh(), Lorene::Time_slice::jtime, Lorene::Map(), Lorene::Time_slice_conf::psi(), Lorene::Tbl::set(), Lorene::Tbl::set_etat_qcq(), Lorene::Time_slice::the_time, and Lorene::Tensor::trace().

## B_hata()

const Scalar & Lorene::Time_slice_conf::B_hata | ( |  | ) | const

virtual inherited

Returns the potential of .

See the documentation of `Sym_tensor_tt` for details. Returns the value at the current time step (`jtime` ).

Definition at line 678 of file time_slice_conf.C.

References A_hata_evol, B_hata_evol, Lorene::Scalar::dec_dzpuis(), Lorene::Scalar::get_dzpuis(), hata_evol, Lorene::Time_slice::jtime, and Lorene::Time_slice::the_time.

## B_hh()

const Scalar & Lorene::Tslice_dirac_max::B_hh | ( |  | ) | const

virtual

Returns the potential of .

See the documentation of `Sym_tensor_tt` for details. Returns the value at the current time step (`jtime` ).

Definition at line 536 of file tslice_dirac_max.C.

References B_hh_evol, Lorene::Time_slice_conf::hh_evol, Lorene::Time_slice::jtime, and Lorene::Time_slice::the_time.

## beta()

const Vector & Lorene::Time_slice::beta | ( |  | ) | const

virtual inherited

shift vector at the current time step (`jtime` )

Definition at line 87 of file time_slice_access.C.

References beta_evol, and jtime.

## check_dynamical_equations()

Tbl Lorene::Time_slice::check_dynamical_equations | ( | const Sym_tensor * | strain_tensor = 0x0,
|  | const Scalar * | energy_density = 0x0,
|  | ostream & | ost = cout,
|  | bool | verb = true ) const

inherited

Checks the level at which the dynamical equations are verified.

Parameters

  strain_tensor | : a pointer on the strain_tensor measured by the Eulerian observer of 4-velocity ; if this is the null pointer, it is assumed that = 0 (vacuum).
  energy_density | : a pointer on the energy density E (see `check_hamiltonian_constraint`)
  ost | : output stream for a formatted output of the result

Returns
  Tbl 3D of size the number of domains times 3 times 3 (corresponding to the rank-2 tensor, with the symmetry in the components) containing the absolute ( if = 0 ) or the relative (in presence of matter) error in max version.

Definition at line 139 of file tslice_check_einstein.C.

References Lorene::Tensor::annule_domain(), Lorene::Tbl::annule_hard(), beta(), Lorene::contract(), Lorene::Scalar::derive_con(), Lorene::Tensor::derive_con(), Lorene::Sym_tensor::derive_lie(), gam(), Lorene::Tbl::get_dim(), Lorene::Tensor::get_mp(), jtime, k_dd(), k_dd_evol, k_uu(), Lorene::maxabs(), nn(), Lorene::Tensor_sym::position(), Lorene::Metric::ricci(), scheme_order, Lorene::Itbl::set(), Lorene::Tbl::set(), Lorene::Tensor::trace(), trk(), and Lorene::Tensor::up_down().

## check_hamiltonian_constraint()

Tbl Lorene::Time_slice::check_hamiltonian_constraint | ( | const Scalar * | energy_density = 0x0,
|  | ostream & | ost = cout,
|  | bool | verb = true ) const

inherited

Checks the level at which the hamiltonian constraint is verified.

Parameters

  energy_density | : a pointer on the energy density E measured by the Eulerian observer of 4-velocity ; if this is the null pointer, it is assumed that E = 0 (vacuum).
  ost | : output stream for a formatted output of the result

Returns
  Tbl of size the number of domains containing the absolute ( if E = 0 ) or the relative (in presence of matter) error in max version.

Definition at line 79 of file tslice_check_einstein.C.

References Lorene::contract(), Lorene::Scalar::dec_dzpuis(), gam(), k_dd(), k_uu(), Lorene::maxabs(), Lorene::Metric::ricci_scal(), and trk().

## check_momentum_constraint()

Tbl Lorene::Time_slice::check_momentum_constraint | ( | const Vector * | momentum_density = 0x0,
|  | ostream & | ost = cout,
|  | bool | verb = true ) const

inherited

Checks the level at which the momentum constraints are verified.

Parameters

  momentum_density | : a pointer on the momentum density measured by the Eulerian observer of 4-velocity ; if this is the null pointer, it is assumed that = 0 (vacuum).
  ost | : output stream for a formatted output of the result

Returns
  Tbl 2D of size the number of domains times 3 (components)containing the absolute ( if = 0 ) or the relative (in presence of matter) error in max version.

Definition at line 109 of file tslice_check_einstein.C.

References Lorene::Scalar::derive_con(), Lorene::Sym_tensor::divergence(), gam(), Lorene::Tensor::get_index_type(), k_uu(), Lorene::maxabs(), and trk().

## compute_sources()

void Lorene::Tslice_dirac_max::compute_sources | ( | const Sym_tensor * | strain_tensor = 0x0 | ) | const

protected

Computes the sources `source_A_XXX_evol` and `source_B_XXX_evol` , for the solution of the evolution equation for and .

Parameters

  strain_tensor | [input] : a pointer on the strain_tensor measured by the Eulerian observer of 4-velocity ; if this is the null pointer (default value), it is assumed that = 0 (vacuum).

Definition at line 219 of file tslice_dirac_max_setAB.C.

References Lorene::Time_slice_conf::A_hata_evol, A_hh_evol, Lorene::Time_slice_conf::aa(), Lorene::Tensor::annule_domain(), Lorene::Time_slice_conf::B_hata_evol, B_hh_evol, Lorene::Time_slice::beta(), Lorene::Sym_tensor::compute_A(), Lorene::Sym_tensor::compute_tilde_B_tt(), Lorene::Metric::con(), Lorene::contract(), Lorene::Metric::cov(), Lorene::Scalar::derive_con(), Lorene::Scalar::derive_cov(), Lorene::Tensor::derive_cov(), Lorene::Tensor_sym::derive_cov(), Lorene::Sym_tensor::derive_lie(), Lorene::Vector::divergence(), Lorene::Tensor::get_mp(), Lorene::Tensor::get_triad(), Lorene::Time_slice_conf::hata(), hh(), Lorene::Tensor::inc_dzpuis(), Lorene::Time_slice::jtime, Lorene::Time_slice_conf::ln_psi(), Lorene::log(), Lorene::Map(), Lorene::maxabs(), Lorene::Time_slice_conf::nn(), Lorene::Vector::ope_killing_conf(), Lorene::Time_slice_conf::psi(), Lorene::Time_slice_conf::psi4(), Lorene::Tensor::set(), Lorene::Sym_tensor_tt::set_A_tildeB(), Lorene::Scalar::set_dzpuis(), Lorene::Tensor::set_etat_zero(), Lorene::Scalar::set_spectral_va(), source_A_hata_evol, source_A_hh_evol, source_B_hata_evol, source_B_hh_evol, Lorene::Scalar::std_spectral_base(), Lorene::Time_slice_conf::tgam(), Lorene::Time_slice::the_time, Lorene::Tensor::trace(), and Lorene::Valeur::ylm().

## compute_X_from_momentum_constraint()

void Lorene::Time_slice_conf::compute_X_from_momentum_constraint | ( | const Vector & | hat_S,
|  | const Sym_tensor_tt & | hata_tt,
|  | int | iter_max = 200,
|  | double | precis = 1.e-12,
|  | double | relax = 0.8,
|  | int | methode_poisson = 6 )

inherited

Computes the vector from the conformally-rescaled momentum , using the momentum constraint.

Definition at line 836 of file time_slice_conf.C.

References Lorene::abs(), Lorene::Metric::connect(), Lorene::contract(), ff, Lorene::Connection::get_delta(), Lorene::Tensor::get_index_type(), hata_evol, hh_evol, Lorene::Time_slice::jtime, Lorene::Time_slice::k_dd_evol, Lorene::Time_slice::k_uu_evol, Lorene::max(), p_vec_X, Lorene::Vector::poisson(), psi(), psi4(), tgam(), Lorene::Time_slice::the_time, and trk().

## del_deriv()

void Lorene::Time_slice_conf::del_deriv | ( |  | ) | const

protected virtual inherited

Deletes all the derived quantities.

Reimplemented from Lorene::Time_slice.

Definition at line 347 of file time_slice_conf.C.

References Lorene::Time_slice::del_deriv(), p_hdirac, p_ln_psi, p_psi4, p_tgamma, p_vec_X, and set_der_0x0().

## evolve()

void Lorene::Tslice_dirac_max::evolve | ( | double | pdt,
|  | int | nb_time_steps,
|  | int | niter_elliptic,
|  | double | relax_elliptic,
|  | int | check_mod,
|  | int | save_mod,
|  | int | method_poisson_vect = 6,
|  | int | nopause = 1,
|  | const char * | graph_device = 0x0,
|  | bool | verbose = true,
|  | const Scalar * | ener_euler = 0x0,
|  | const Vector * | mom_euler = 0x0,
|  | const Scalar * | s_euler = 0x0,
|  | const Sym_tensor * | strain_euler = 0x0 )

Time evolution by resolution of Einstein equations.

Parameters

  pdt | time step dt.
  nb_time_steps | number of time steps for the evolution
  niter_elliptic | number of iterations if the resolution of elliptic equations
  relax_elliptic | relaxation factor for the elliptic equations
  check_mod | determines the frequency of check of the constraint equations: they are checked every `check_mod` time step
  save_mod | determines the frequency of writing to file the monotoring quantities: they are written to file every `save_mod` time step
  method | method_poisson_vect to be used for solving vector Poisson equation (for the shift), see `Vector::poisson(double, const Metric_flat&, int) const`.
  nopause | = 1 if no pause between each time step, 0 otherwise
  graph_device | name of type of graphical device: 0x0 (default value) will result in interactive choice; "/xwin" in X-Window display and "/n" in no output.

Definition at line 120 of file tslice_dirac_max_evolve.C.

References Lorene::Time_slice_conf::A_hata_evol, A_hh(), A_hh_evol, Lorene::Param::add_double_mod(), Lorene::Param::add_int(), Lorene::Param::add_tbl_mod(), adm_mass(), Lorene::Tensor::annule(), Lorene::Scalar::annule_hard(), Lorene::Tbl::annule_hard(), Lorene::arrete(), Lorene::Time_slice_conf::B_hata_evol, B_hh(), B_hh_evol, Lorene::Time_slice::beta(), Lorene::Time_slice::beta_evol, Lorene::central_value(), Lorene::Time_slice::check_dynamical_equations(), Lorene::Time_slice::check_hamiltonian_constraint(), Lorene::Time_slice::check_momentum_constraint(), Lorene::Param::clean_all(), compute_sources(), Lorene::Time_slice_conf::compute_X_from_momentum_constraint(), Lorene::Time_slice_conf::del_deriv(), Lorene::Time_slice::depth, Lorene::Scalar::get_etat(), Lorene::Tensor::get_mp(), Lorene::Scalar::get_spectral_base(), Lorene::Tensor::get_triad(), Lorene::Time_slice_conf::hata(), Lorene::Time_slice_conf::hata_evol, hh(), hh_det_one(), Lorene::Time_slice_conf::hh_evol, Lorene::Tensor::inc_dzpuis(), Lorene::Time_slice::jtime, Lorene::Time_slice_conf::k_dd(), Lorene::log(), Lorene::Map(), Lorene::maxabs_all_domains(), Lorene::Sym_tensor::mu(), Lorene::Base_val::mult_cost(), Lorene::Scalar::mult_r(), Lorene::Base_val::mult_x(), Lorene::Time_slice_conf::nn(), Lorene::Time_slice_conf::npsi(), Lorene::Time_slice_conf::npsi_evol, Lorene::Time_slice_conf::psi(), Lorene::Time_slice_conf::psi_evol, Lorene::Evolution< TyT >::save(), Lorene::Time_slice::save(), Lorene::Tbl::set(), Lorene::Tensor::set(), Lorene::Sym_tensor_tt::set_A_tildeB(), set_AB_hh(), Lorene::Scalar::set_domain(), Lorene::Scalar::set_dzpuis(), Lorene::Tbl::set_etat_qcq(), Lorene::Tensor::set_etat_zero(), Lorene::Time_slice_conf::set_npsi_del_n(), Lorene::Time_slice_conf::set_psi_del_npsi(), Lorene::Scalar::set_spectral_base(), Lorene::Scalar::set_spectral_va(), solve_beta(), solve_npsi(), solve_psi(), source_A_hata_evol, source_A_hh_evol, source_B_hata_evol, source_B_hh_evol, Lorene::Scalar::std_spectral_base(), Lorene::Time_slice::the_time, Lorene::Evolution< TyT >::time_derive(), trh(), Lorene::Evolution_full< TyT >::update(), Lorene::Evolution_std< TyT >::update(), Lorene::Time_slice_conf::vec_X(), Lorene::Valeur::ylm(), and Lorene::Valeur::ylm_i().

## gam()

const Metric & Lorene::Time_slice::gam | ( |  | ) | const

inherited

Induced metric at the current time step (`jtime` ).

Definition at line 95 of file time_slice_access.C.

References gam_dd(), and p_gamma.

## gam_dd()

const Sym_tensor & Lorene::Time_slice_conf::gam_dd | ( |  | ) | const

virtual inherited

Induced metric (covariant components ) at the current time step (`jtime` ).

Reimplemented from Lorene::Time_slice.

Definition at line 608 of file time_slice_conf.C.

References Lorene::Time_slice::gam_dd_evol, Lorene::Time_slice::jtime, psi4(), tgam(), and Lorene::Time_slice::the_time.

## gam_uu()

const Sym_tensor & Lorene::Time_slice_conf::gam_uu | ( |  | ) | const

virtual inherited

Induced metric (contravariant components ) at the current time step (`jtime` ).

Reimplemented from Lorene::Time_slice.

Definition at line 619 of file time_slice_conf.C.

References Lorene::Time_slice::gam_uu_evol, Lorene::Time_slice::jtime, psi4(), tgam(), and Lorene::Time_slice::the_time.

## get_latest_j()

int Lorene::Time_slice::get_latest_j | ( |  | ) | const

inline inherited

Gets the latest value of time step index.

Definition at line 343 of file time_slice.h.

References jtime.

## get_scheme_order()

int Lorene::Time_slice::get_scheme_order | ( |  | ) | const

inline inherited

Gets the order of the finite-differences scheme.

Definition at line 340 of file time_slice.h.

References scheme_order.

## get_time()

const Evolution_std< double > & Lorene::Time_slice::get_time | ( |  | ) | const

inline inherited

Gets the time coordinate t at successive time steps.

Definition at line 346 of file time_slice.h.

References the_time.

## hata()

const Sym_tensor & Lorene::Time_slice_conf::hata | ( |  | ) | const

virtual inherited

Conformal representation of the traceless part of the extrinsic curvature: .

Returns the value at the current time step (`jtime` ).

Definition at line 772 of file time_slice_conf.C.

References Lorene::Time_slice::beta(), Lorene::Sym_tensor::derive_lie(), Lorene::Vector::divergence(), ff, hata_evol, hh(), hh_evol, Lorene::Tensor::inc_dzpuis(), Lorene::Time_slice::jtime, nn(), Lorene::Vector::ope_killing_conf(), psi(), psi4(), Lorene::Time_slice::scheme_order, and Lorene::Time_slice::the_time.

## hdirac()

const Vector & Lorene::Tslice_dirac_max::hdirac | ( |  | ) | const

virtual

Vector which vanishes in Dirac gauge.

It is null in the present case...

Reimplemented from Lorene::Time_slice_conf.

Definition at line 507 of file tslice_dirac_max.C.

References Lorene::Time_slice_conf::p_hdirac.

## hh()

const Sym_tensor & Lorene::Tslice_dirac_max::hh | ( | Param * | par_bc = 0x0,
|  | Param * | par_mat = 0x0 ) const

virtual

Deviation of the conformal metric from the flat metric : .

Returns the value at the current time step (`jtime` ).

Reimplemented from Lorene::Time_slice_conf.

Definition at line 474 of file tslice_dirac_max.C.

References A_hh_evol, B_hh_evol, hh_det_one(), Lorene::Time_slice_conf::hh_evol, and Lorene::Time_slice::jtime.

## hh_det_one() [1/2]

void Lorene::Tslice_dirac_max::hh_det_one | ( | const Sym_tensor_tt & | hijtt,
|  | Param * | par_mat = 0x0 ) const

protected

Computes from the TT part using the condition , which fixes the trace of .

Parameters

  hijtt | : the TT part.

Definition at line 168 of file tslice_dirac_max_setAB.C.

References Lorene::Time_slice::adm_mass_evol, Lorene::Time_slice::gam_dd_evol, Lorene::Time_slice::gam_uu_evol, Lorene::Tensor::get_mp(), Lorene::Time_slice_conf::hh_evol, Lorene::Time_slice::jtime, Lorene::Map(), Lorene::maxabs(), Lorene::Time_slice::p_gamma, Lorene::Time_slice_conf::p_hdirac, Lorene::Time_slice_conf::p_tgamma, Lorene::Tensor::set_etat_zero(), Lorene::Sym_tensor::set_longit_trans(), Lorene::Sym_tensor_trans::set_tt_part_det_one(), Lorene::Time_slice_conf::tgam(), Lorene::Time_slice::the_time, and Lorene::Sym_tensor_trans::the_trace().

## hh_det_one() [2/2]

void Lorene::Tslice_dirac_max::hh_det_one | ( | int | j,
|  | Param * | par_bc = 0x0,
|  | Param * | par_mat = 0x0 ) const

protected

Computes from the values of A and and using the condition , which fixes the trace of .

Parameters

  j | time step at which the computation of is required.

Definition at line 109 of file tslice_dirac_max_setAB.C.

References A_hh_evol, Lorene::Time_slice::adm_mass_evol, B_hh_evol, Lorene::Metric::determinant(), Lorene::Time_slice::gam_dd_evol, Lorene::Time_slice::gam_uu_evol, Lorene::Time_slice_conf::hh_evol, Lorene::Time_slice::jtime, Lorene::Map(), Lorene::maxabs(), Lorene::Time_slice::p_gamma, Lorene::Time_slice_conf::p_hdirac, Lorene::Time_slice_conf::p_tgamma, Lorene::Sym_tensor_trans::set_AtBtt_det_one(), Lorene::Tensor::set_etat_zero(), Lorene::Sym_tensor::set_longit_trans(), Lorene::Time_slice_conf::tgam(), Lorene::Time_slice::the_time, and Lorene::Sym_tensor_trans::the_trace().

## initial_data_cts()

void Lorene::Tslice_dirac_max::initial_data_cts | ( | const Sym_tensor & | uu,
|  | const Scalar & | trk_in,
|  | const Scalar & | trk_point,
|  | double | pdt,
|  | double | precis = 1.e-12,
|  | int | method_poisson_vect = 6,
|  | const char * | graph_device = 0x0,
|  | const Scalar * | ener_dens = 0x0,
|  | const Vector * | mom_dens = 0x0,
|  | const Scalar * | trace_stress = 0x0 )

virtual

Computes valid initial data by solving the constraint equations in the conformal thin-sandwich approach.

Parameters

  uu | value of (freely specifiable data). This quantity must be trace-free with respect to the conformal metric , reflecting the unimodular character of .
  trk_in | value of (freely specifiable data)
  trk_point | value of (freely specifiable data)
  pdt | time step, to be used in order to fill `depth` slices
  precis | convergence threshold required to stop the iteration
  method_poisson_vect | method to be used for solving vector Poisson equation (for the shift), see `Vector::poisson(double, const Metric_flat&, int) const`.
  graph_device | name of type of graphical device: 0x0 (default value) will result in interactive choice; "/xwin" in X-Window display and "/n" in no output.
  ener_dens | matter energy density E as measured by the Eulerian observer; this quantity is passed as a pointer, the null value of which (default) meaning E=0.
  mom_dens | matter momentum density J as measured by the Eulerian observer; this quantity is passed as a pointer, the null value of which (default) meaning J=0.
  trace_stress | trace of the matter stress S as measured by the Eulerian observer; this quantity is passed as a pointer, the null value of which (default) meaning S=0.

Definition at line 352 of file tslice_dirac_max.C.

References Lorene::Time_slice_conf::A_hata_evol, A_hh_evol, Lorene::Tensor::annule_domain(), Lorene::Time_slice_conf::B_hata_evol, B_hh_evol, compute_sources(), Lorene::Time_slice_conf::del_deriv(), Lorene::Time_slice::depth, Lorene::Scalar::get_etat(), Lorene::Tensor::get_mp(), Lorene::Time_slice_conf::hh_evol, Lorene::Time_slice::jtime, Lorene::maxabs(), Lorene::Scalar::set_dzpuis(), and Lorene::Time_slice::the_time.

## initialize_sources_copy()

void Lorene::Tslice_dirac_max::initialize_sources_copy | ( |  | ) | const

protected

Definition at line 411 of file tslice_dirac_max_setAB.C.

## k_dd()

const Sym_tensor & Lorene::Time_slice_conf::k_dd | ( |  | ) | const

virtual inherited

Extrinsic curvature tensor (covariant components ) at the current time step (`jtime` ).

Reimplemented from Lorene::Time_slice.

Definition at line 630 of file time_slice_conf.C.

References Lorene::Time_slice::gam(), Lorene::Time_slice::jtime, Lorene::Time_slice::k_dd_evol, k_uu(), and Lorene::Time_slice::the_time.

## k_uu()

const Sym_tensor & Lorene::Time_slice_conf::k_uu | ( |  | ) | const

virtual inherited

Extrinsic curvature tensor (contravariant components ) at the current time step (`jtime` ).

Reimplemented from Lorene::Time_slice.

Definition at line 643 of file time_slice_conf.C.

References Lorene::Time_slice::gam(), hata(), Lorene::Time_slice::jtime, Lorene::Time_slice::k_uu_evol, psi(), psi4(), Lorene::Time_slice::the_time, and trk().

## ln_psi()

const Scalar & Lorene::Time_slice_conf::ln_psi | ( |  | ) | const

inherited

Logarithm of at the current time step (`jtime` ).

Definition at line 719 of file time_slice_conf.C.

References Lorene::log(), p_ln_psi, and psi().

## nn()

const Scalar & Lorene::Time_slice_conf::nn | ( |  | ) | const

virtual inherited

Lapse function N at the current time step (`jtime` ).

Reimplemented from Lorene::Time_slice.

Definition at line 591 of file time_slice_conf.C.

References Lorene::Time_slice::jtime, Lorene::Time_slice::n_evol, npsi_evol, psi_evol, and Lorene::Time_slice::the_time.

## npsi()

const Scalar & Lorene::Time_slice_conf::npsi | ( |  | ) | const

virtual inherited

Factor at the current time step (`jtime` ).

Definition at line 732 of file time_slice_conf.C.

References Lorene::Time_slice::jtime, Lorene::Time_slice::n_evol, npsi_evol, psi_evol, and Lorene::Time_slice::the_time.

## operator=()

void Lorene::Tslice_dirac_max::operator= | ( | const Tslice_dirac_max & | tin | ) |

Definition at line 321 of file tslice_dirac_max.C.

## operator>>()

ostream & Lorene::Time_slice::operator>> | ( | ostream & | flux | ) | const

protected virtual inherited

Operator >> (virtual function called by the operator<<).

Reimplemented in Lorene::Isol_hor.

Definition at line 411 of file time_slice.C.

References adm_mass(), adm_mass_evol, beta_evol, depth, gam_dd_evol, gam_uu_evol, jtime, k_dd_evol, k_uu_evol, Lorene::maxabs(), n_evol, p_gamma, scheme_order, the_time, and trk_evol.

## psi()

const Scalar & Lorene::Time_slice_conf::psi | ( |  | ) | const

virtual inherited

Conformal factor relating the physical metric to the conformal one: .

is defined by

Returns the value at the current time step (`jtime` ).

Definition at line 693 of file time_slice_conf.C.

References Lorene::Time_slice::jtime, Lorene::Time_slice::n_evol, npsi_evol, psi_evol, and Lorene::Time_slice::the_time.

## psi4()

const Scalar & Lorene::Time_slice_conf::psi4 | ( |  | ) | const

inherited

Factor at the current time step (`jtime` ).

Definition at line 707 of file time_slice_conf.C.

References p_psi4, Lorene::pow(), and psi().

## sauve()

void Lorene::Tslice_dirac_max::sauve | ( | FILE * | fich,
|  | bool | partial_save ) const

protected virtual

Total or partial saves in a binary file.

This protected method is to be called either from public method `save` or from method `sauve` of a derived class.

Parameters

  fich | binary file
  partial_save | indicates whether the whole object must be saved.

Reimplemented from Lorene::Time_slice.

Definition at line 587 of file tslice_dirac_max.C.

References A_hh(), A_hh_evol, B_hh(), B_hh_evol, Lorene::Time_slice::depth, Lorene::fwrite_be(), Lorene::Time_slice_conf::hh_evol, Lorene::Time_slice::jtime, and Lorene::Time_slice::sauve().

## save()

void Lorene::Time_slice::save | ( | const char * | rootname | ) | const

inherited

Saves in a binary file.

The saved data is sufficient to restore the whole time slice via the constructor from file.

Parameters

  rootname | root for the file name; the current time step index will be appended to it.

Definition at line 461 of file time_slice.C.

References beta(), depth, Lorene::fwrite_be(), Lorene::Tensor::get_mp(), Lorene::Tensor::get_triad(), jtime, Lorene::Map(), nn(), Lorene::Base_vect::sauve(), Lorene::Mg3d::sauve(), and sauve().

## set_AB_hh()

void Lorene::Tslice_dirac_max::set_AB_hh | ( | const Scalar & | A_in,
|  | const Scalar & | B_in )

virtual

Sets the potentials A and of the TT part of (see the documentation of `Sym_tensor` for details).

is not modified. Sets the value at the current time step (`jtime` ).

Definition at line 84 of file tslice_dirac_max_setAB.C.

References A_hh_evol, Lorene::Time_slice::adm_mass_evol, B_hh_evol, Lorene::Time_slice::gam_dd_evol, Lorene::Time_slice::gam_uu_evol, Lorene::Time_slice_conf::hh_evol, Lorene::Time_slice::jtime, Lorene::Time_slice::p_gamma, Lorene::Time_slice_conf::p_hdirac, Lorene::Time_slice_conf::p_tgamma, and Lorene::Time_slice::the_time.

## set_der_0x0()

void Lorene::Time_slice_conf::set_der_0x0 | ( |  | ) | const

protected inherited

Sets to `0x0` all the pointers on derived quantities.

Definition at line 361 of file time_slice_conf.C.

References p_hdirac, p_ln_psi, p_psi4, p_tgamma, and p_vec_X.

## set_hata()

void Lorene::Time_slice_conf::set_hata | ( | const Sym_tensor & | hata_in | ) |

virtual inherited

Sets the conformal representation of the traceless part of the extrinsic curvature: .

Sets the value at the current time step (`jtime` ), and updates the potentials `A_hata_evol`, `B_hata_evol` and `p_vec_X` accordingly.

Definition at line 534 of file time_slice_conf.C.

References A_hata_evol, B_hata_evol, hata_evol, Lorene::Time_slice::jtime, Lorene::Time_slice::k_dd_evol, Lorene::Time_slice::k_uu_evol, and Lorene::Time_slice::the_time.

## set_hata_from_XAB()

void Lorene::Time_slice_conf::set_hata_from_XAB | ( | Param * | par_bc = 0x0,
|  | Param * | par_mat = 0x0 )

virtual inherited

Sets the conformal representation of the traceless part of the extrinsic curvature from its potentials A, and .

These potentials must be up-to-date. It sets the value at the current time step (`jtime` ).

Definition at line 566 of file time_slice_conf.C.

References A_hata_evol, B_hata_evol, ff, hata_evol, Lorene::Tensor::inc_dzpuis(), Lorene::Time_slice::jtime, Lorene::Time_slice::k_dd_evol, Lorene::Time_slice::k_uu_evol, Lorene::Map(), p_vec_X, Lorene::Sym_tensor_tt::set_A_tildeB(), and Lorene::Time_slice::the_time.

## set_hata_TT()

void Lorene::Time_slice_conf::set_hata_TT | ( | const Sym_tensor_tt & | hata_tt | ) |

virtual inherited

Sets the TT part of (see member `hata_evol` ).

Sets the value at current time-step (`jtime` ) and updates the potentials A and .

Definition at line 546 of file time_slice_conf.C.

References A_hata_evol, B_hata_evol, Lorene::Sym_tensor::compute_A(), Lorene::Sym_tensor::compute_tilde_B_tt(), Lorene::Scalar::dec_dzpuis(), Lorene::Scalar::get_dzpuis(), hata_evol, Lorene::Time_slice::jtime, Lorene::Time_slice::k_dd_evol, Lorene::Time_slice::k_uu_evol, and Lorene::Time_slice::the_time.

## set_hh()

void Lorene::Tslice_dirac_max::set_hh | ( | const Sym_tensor & | hh_in | ) |

virtual

Sets the deviation of the conformal metric from the flat metric : .

must be such that . Sets the value at the current time step (`jtime` ).

Reimplemented from Lorene::Time_slice_conf.

Definition at line 336 of file tslice_dirac_max.C.

References A_hh_evol, B_hh_evol, Lorene::Time_slice::jtime, Lorene::Time_slice_conf::set_hh(), source_A_hata_evol, source_A_hh_evol, source_B_hata_evol, and source_B_hh_evol.

## set_khi_mu()

void Lorene::Tslice_dirac_max::set_khi_mu | ( | const Scalar & | khi_in,
|  | const Scalar & | mu_in )

virtual

Sets the potentials and of the TT part of (see the documentation of `Sym_tensor_tt` for details).

The value of is then deduced from the unimodularity condition on the conformal metric. Sets the value at the current time step (`jtime` ).

Definition at line 408 of file tslice_dirac_max.C.

References Lorene::Scalar::dec_dzpuis(), Lorene::Tensor::get_mp(), Lorene::Time_slice_conf::hh_evol, Lorene::Time_slice::jtime, Lorene::Map(), Lorene::Tensor::set_etat_zero(), Lorene::Sym_tensor_tt::set_khi_mu(), Lorene::Sym_tensor::set_longit_trans(), Lorene::Time_slice::the_time, Lorene::Sym_tensor_trans::the_trace(), and Lorene::Sym_tensor_trans::trace_from_det_one().

## set_npsi_del_n()

void Lorene::Time_slice_conf::set_npsi_del_n | ( | const Scalar & | npsi_in | ) |

virtual inherited

Sets the factor at the current time step (`jtime` ) and deletes the value of N.

Definition at line 478 of file time_slice_conf.C.

References Lorene::Time_slice::adm_mass_evol, Lorene::Time_slice::jtime, Lorene::Time_slice::n_evol, npsi_evol, and Lorene::Time_slice::the_time.

## set_npsi_del_psi()

void Lorene::Time_slice_conf::set_npsi_del_psi | ( | const Scalar & | npsi_in | ) |

virtual inherited

Sets the factor at the current time step (`jtime` ) and deletes the value of .

Definition at line 453 of file time_slice_conf.C.

References Lorene::Time_slice::adm_mass_evol, Lorene::Time_slice::gam_dd_evol, Lorene::Time_slice::gam_uu_evol, Lorene::Time_slice::jtime, npsi_evol, Lorene::Time_slice::p_gamma, p_ln_psi, p_psi4, psi_evol, and Lorene::Time_slice::the_time.

## set_psi_del_n()

void Lorene::Time_slice_conf::set_psi_del_n | ( | const Scalar & | psi_in | ) |

virtual inherited

Sets the conformal factor relating the physical metric to the conformal one: .

is defined by

Sets the value at the current time step (`jtime` ) and deletes the value of N.

Definition at line 428 of file time_slice_conf.C.

References Lorene::Time_slice::adm_mass_evol, Lorene::Time_slice::gam_dd_evol, Lorene::Time_slice::gam_uu_evol, Lorene::Time_slice::jtime, Lorene::Time_slice::n_evol, Lorene::Time_slice::p_gamma, p_ln_psi, p_psi4, psi_evol, and Lorene::Time_slice::the_time.

## set_psi_del_npsi()

void Lorene::Time_slice_conf::set_psi_del_npsi | ( | const Scalar & | psi_in | ) |

virtual inherited

Sets the conformal factor relating the physical metric to the conformal one: .

is defined by

Sets the value at the current time step (`jtime` ) and deletes the value of .

Definition at line 404 of file time_slice_conf.C.

References Lorene::Time_slice::adm_mass_evol, Lorene::Time_slice::gam_dd_evol, Lorene::Time_slice::gam_uu_evol, Lorene::Time_slice::jtime, npsi_evol, Lorene::Time_slice::p_gamma, p_ln_psi, p_psi4, psi_evol, and Lorene::Time_slice::the_time.

## set_scheme_order()

void Lorene::Time_slice::set_scheme_order | ( | int | ord | ) |

inline inherited

Sets the order of the finite-differences scheme.

Definition at line 331 of file time_slice.h.

References scheme_order.

## set_trh()

void Lorene::Tslice_dirac_max::set_trh | ( | const Scalar & | trh_in | ) |

virtual

Sets the trace, with respect to the flat metric `ff` , of .

Sets the value at the current time step (`jtime` ). Note that this method does not ensure that the conformal metric is unimodular.

Definition at line 437 of file tslice_dirac_max.C.

References Lorene::Time_slice::adm_mass_evol, Lorene::Time_slice::gam_dd_evol, Lorene::Time_slice::gam_uu_evol, Lorene::Time_slice_conf::hh_evol, Lorene::Time_slice::jtime, Lorene::Time_slice::p_gamma, Lorene::Time_slice_conf::p_hdirac, Lorene::Time_slice_conf::p_tgamma, source_A_hata_evol, source_A_hh_evol, source_B_hata_evol, source_B_hh_evol, and Lorene::Time_slice::the_time.

## solve_beta()

Vector Lorene::Tslice_dirac_max::solve_beta | ( | int | method = 6 | ) | const

virtual

Solves the elliptic equation for the shift vector from (Eq.

(73) of Bonazzola et al. 2004).

Parameters

  method | method to be used for solving vector Poisson equation (for the shift), see `Vector::poisson(double, const Metric_flat&, int) const`.

Returns
  solution of the elliptic equation (flat vector Laplacian) for the shift with the source computed from the quantities at the current time step.

Definition at line 224 of file tslice_dirac_max_solve.C.

References Lorene::Time_slice_conf::aa(), Lorene::Time_slice::beta(), Lorene::contract(), Lorene::Scalar::derive_con(), Lorene::Tensor::derive_con(), Lorene::Sym_tensor::divergence(), Lorene::Vector::divergence(), hh(), Lorene::Tensor::inc_dzpuis(), Lorene::maxabs(), Lorene::Time_slice_conf::nn(), and Lorene::Vector::poisson().

## solve_npsi()

Scalar Lorene::Tslice_dirac_max::solve_npsi | ( | const Scalar * | ener_dens = 0x0,
|  | const Scalar * | trace_stress = 0x0 ) const

virtual

Solves the elliptic equation for (maximal slicing condition + Hamiltonian constraint).

Parameters

  ener_dens | conformal matter energy density , where E is measured by the Eulerian observer; this quantity is passed as a pointer, the null value of which (default) meaning E=0.
  trace_stress | trace of the conformal matter stress , where S is measured by the Eulerian observer; this quantity is passed as a pointer, the null value of which (default) meaning S=0.

Returns
  solution of the elliptic equation (flat Laplacian) for with the source computed from the quantities at the current time step.

Definition at line 118 of file tslice_dirac_max_solve.C.

References Lorene::Time_slice_conf::aa(), Lorene::contract(), Lorene::Metric::cov(), Lorene::Scalar::derive_cov(), Lorene::Tensor::derive_cov(), Lorene::Tensor_sym::derive_cov(), Lorene::Scalar::get_etat(), Lorene::Tensor::get_mp(), hh(), Lorene::Scalar::inc_dzpuis(), Lorene::Scalar::laplacian(), Lorene::Map(), Lorene::maxabs(), Lorene::Time_slice_conf::npsi(), Lorene::Scalar::poisson(), Lorene::Time_slice_conf::psi(), Lorene::Time_slice_conf::psi4(), Lorene::Scalar::set_etat_zero(), Lorene::Scalar::std_spectral_base(), Lorene::Time_slice_conf::tgam(), and Lorene::Tensor::up_down().

## solve_psi()

Scalar Lorene::Tslice_dirac_max::solve_psi | ( | const Scalar * | ener_dens = 0x0 | ) | const

virtual

Solves the elliptic equation for the conformal factor $\Psi$ (Hamiltonian constraint).

Parameters

  ener_dens | conformal matter energy density , where E is measured by the Eulerian observer; this quantity is passed as a pointer, the null value of which (default) meaning E=0.

Returns
  solution of the elliptic equation (flat Laplacian) for the lapse with the source computed from the quantities at the current time step.

Definition at line 172 of file tslice_dirac_max_solve.C.

References Lorene::contract(), Lorene::Metric::cov(), Lorene::Scalar::derive_cov(), Lorene::Tensor::derive_cov(), Lorene::Tensor_sym::derive_cov(), Lorene::Scalar::get_etat(), Lorene::Tensor::get_mp(), Lorene::Time_slice_conf::hata(), hh(), Lorene::Scalar::inc_dzpuis(), Lorene::Scalar::laplacian(), Lorene::Map(), Lorene::maxabs(), Lorene::Scalar::poisson(), Lorene::pow(), Lorene::Time_slice_conf::psi(), Lorene::Scalar::set_etat_zero(), Lorene::Scalar::std_spectral_base(), Lorene::Time_slice_conf::tgam(), and Lorene::Tensor::up_down().

## tgam()

const Metric & Lorene::Time_slice_conf::tgam | ( |  | ) | const

virtual inherited

Conformal metric Returns the value at the current time step (`jtime` ).

Reimplemented in Lorene::Isol_hor.

Definition at line 747 of file time_slice_conf.C.

References ff, hh(), and p_tgamma.

## trh()

const Scalar & Lorene::Tslice_dirac_max::trh | ( |  | ) | const

virtual

Computes the trace `h`, with respect to the flat metric `ff` , of .

Returns the value at the current time step (`jtime` ).

Definition at line 547 of file tslice_dirac_max.C.

References hh_det_one(), and Lorene::Time_slice::jtime.

## trk()

const Scalar & Lorene::Tslice_dirac_max::trk | ( |  | ) | const

virtual

Trace K of the extrinsic curvature at the current time step (`jtime` ).

It is null in the present case (maximal slicing)

Reimplemented from Lorene::Time_slice_conf.

Definition at line 491 of file tslice_dirac_max.C.

References Lorene::Time_slice::jtime, Lorene::Scalar::set_etat_zero(), Lorene::Time_slice::the_time, and Lorene::Time_slice::trk_evol.

## vec_X()

const Vector & Lorene::Time_slice_conf::vec_X | ( | int | method_poisson = 6 | ) | const

virtual inherited

Vector representing the longitudinal part of .

(see the documentation of `hata_evol`)

Definition at line 825 of file time_slice_conf.C.

References ff, hata_evol, Lorene::Tensor::inc_dzpuis(), Lorene::Time_slice::jtime, p_vec_X, and Lorene::Vector::poisson().

## Member Data Documentation

## A_hata_evol

Evolution_std<Scalar> Lorene::Time_slice_conf::A_hata_evol

mutable protected inherited

Potential A associated with the symmetric tensor .

(see documentation of `Sym_tensor::p_aaa`).

Definition at line 547 of file time_slice.h.

## A_hh_evol

Evolution_std<Scalar> Lorene::Tslice_dirac_max::A_hh_evol

mutable protected

The A potential of .

(see the documentation of `Sym_tensor::p_aaa` for details).

Definition at line 977 of file time_slice.h.

## adm_mass_evol

Evolution_full<Tbl> Lorene::Time_slice::adm_mass_evol

mutable protected inherited

ADM mass at each time step, since the creation of the slice.

At a given time step `j`, `adm_mass_evol`[j] is a 1-D `Tbl` of size the number `nz` of domains, containing the "ADM mass" evaluated at the outer boundary of each domain. The true ADM mass is thus the last value, i.e. `adm_mass_evol`[j](nz-1).

Definition at line 233 of file time_slice.h.

## B_hata_evol

Evolution_std<Scalar> Lorene::Time_slice_conf::B_hata_evol

mutable protected inherited

Potential associated with the symmetric tensor .

(see documentation of `Sym_tensor::p_tilde_b`).

Definition at line 552 of file time_slice.h.

## B_hh_evol

Evolution_std<Scalar> Lorene::Tslice_dirac_max::B_hh_evol

mutable protected

The potential of .

(see the documentation of `Sym_tensor::p_tilde_b` for details).

Definition at line 983 of file time_slice.h.

## beta_evol

Evolution_std<Vector> Lorene::Time_slice::beta_evol

mutable protected inherited

Values at successive time steps of the shift vector .

Definition at line 219 of file time_slice.h.

## depth

int Lorene::Time_slice::depth

protected inherited

Number of stored time slices.

Definition at line 179 of file time_slice.h.

## ff

The with respect to the flat metric c Lorene::Tslice_dirac_max::ff

protected

Definition at line 1009 of file time_slice.h.

## gam_dd_evol

Evolution_std<Sym_tensor> Lorene::Time_slice::gam_dd_evol

mutable protected inherited

Values at successive time steps of the covariant components of the induced metric .

Definition at line 198 of file time_slice.h.

## gam_uu_evol

Evolution_std<Sym_tensor> Lorene::Time_slice::gam_uu_evol

mutable protected inherited

Values at successive time steps of the contravariant components of the induced metric .

Definition at line 203 of file time_slice.h.

## h

The with respect to the flat metric c of f$ Lorene::Tslice_dirac_max::h

protected

Initial value:
{ij} \f$.
mutable Evolution_std<Scalar> trh_evol
Lorene::Evolution_std
Time evolution with partial storage (*** under development ***).
Definition evolution.h:371

Definition at line 1009 of file time_slice.h.

## hata_evol

Evolution_std<Sym_tensor> Lorene::Time_slice_conf::hata_evol

mutable protected inherited

Values at successive time steps of the components .

It is the conformal representation of the traceless part of the extrinsic curvature: . One can uniquely (up to the boundary conditions) define the decomposition: , where represents the longitudinal part and is the transverse-traceless part.

Definition at line 542 of file time_slice.h.

## hh_evol

Evolution_std<Sym_tensor> Lorene::Time_slice_conf::hh_evol

mutable protected inherited

Values at successive time steps of the components .

It is the deviation of the conformal metric from the flat metric : .

Definition at line 530 of file time_slice.h.

## jtime

int Lorene::Time_slice::jtime

protected inherited

Time step index of the latest slice.

Definition at line 190 of file time_slice.h.

## k_dd_evol

Evolution_std<Sym_tensor> Lorene::Time_slice::k_dd_evol

mutable protected inherited

Values at successive time steps of the covariant components of the extrinsic curvature tensor .

Definition at line 208 of file time_slice.h.

## k_uu_evol

Evolution_std<Sym_tensor> Lorene::Time_slice::k_uu_evol

mutable protected inherited

Values at successive time steps of the contravariant components of the extrinsic curvature tensor .

Definition at line 213 of file time_slice.h.

## n_evol

Evolution_std<Scalar> Lorene::Time_slice::n_evol

mutable protected inherited

Values at successive time steps of the lapse function N.

Definition at line 216 of file time_slice.h.

## npsi_evol

Evolution_std<Scalar> Lorene::Time_slice_conf::npsi_evol

mutable protected inherited

Values at successive time steps of the factor .

Definition at line 522 of file time_slice.h.

## p_gamma

Metric* Lorene::Time_slice::p_gamma

mutable protected inherited

Pointer on the induced metric at the current time step (`jtime`).

Definition at line 239 of file time_slice.h.

## p_hdirac

Vector* Lorene::Time_slice_conf::p_hdirac

mutable protected inherited

Pointer on the vector (which vanishes in Dirac gauge), at the current time step (`jtime`).

Definition at line 571 of file time_slice.h.

## p_ln_psi

Scalar* Lorene::Time_slice_conf::p_ln_psi

mutable protected inherited

Pointer on the logarithm of at the current time step (`jtime`).

Definition at line 566 of file time_slice.h.

## p_psi4

Scalar* Lorene::Time_slice_conf::p_psi4

mutable protected inherited

Pointer on the factor at the current time step (`jtime`).

Definition at line 563 of file time_slice.h.

## p_tgamma

Metric* Lorene::Time_slice_conf::p_tgamma

mutable protected inherited

Pointer on the conformal metric at the current time step (`jtime`).

Definition at line 560 of file time_slice.h.

## p_vec_X

Vector* Lorene::Time_slice_conf::p_vec_X

mutable protected inherited

Pointer on the vector representing the longitudinal part of .

(see the documentation of `hata_evol`)

Definition at line 577 of file time_slice.h.

## psi_evol

Evolution_std<Scalar> Lorene::Time_slice_conf::psi_evol

mutable protected inherited

Values at successive time steps of the conformal factor relating the physical metric to the conformal one: .

is defined by

Definition at line 517 of file time_slice.h.

## scheme_order

int Lorene::Time_slice::scheme_order

protected inherited

Order of the finite-differences scheme for the computation of time derivatives.

This order is not constant and can be adjusted via `set_scheme_order()` .

Definition at line 187 of file time_slice.h.

## source_A_hata_evol

Evolution_std<Scalar> Lorene::Tslice_dirac_max::source_A_hata_evol

mutable protected

The potential A of the source of equation for .

(see the documentation of `Sym_tensor::p_aaa` for details).

Definition at line 1001 of file time_slice.h.

## source_A_hh_evol

Evolution_std<Scalar> Lorene::Tslice_dirac_max::source_A_hh_evol

mutable protected

The A potential of the source of equation for .

(see the documentation of `Sym_tensor::p_aaa` for details).

Definition at line 989 of file time_slice.h.

## source_B_hata_evol

Evolution_std<Scalar> Lorene::Tslice_dirac_max::source_B_hata_evol

mutable protected

The potential of the source of equation for .

(see the documentation of `Sym_tensor::p_tilde_b` for details).

Definition at line 1007 of file time_slice.h.

## source_B_hh_evol

Evolution_std<Scalar> Lorene::Tslice_dirac_max::source_B_hh_evol

mutable protected

The potential of the source of equation for .

(see the documentation of `Sym_tensor::p_tilde_b` for details).

Definition at line 995 of file time_slice.h.

## the_time

Evolution_std<double> Lorene::Time_slice::the_time

protected inherited

Time label of each slice.

Definition at line 193 of file time_slice.h.

## trace

The Lorene::Tslice_dirac_max::trace

protected

Definition at line 1009 of file time_slice.h.

## trk_evol

Evolution_std<Scalar> Lorene::Time_slice::trk_evol

mutable protected inherited

Values at successive time steps of the trace K of the extrinsic curvature.

Definition at line 224 of file time_slice.h.

The documentation for this class was generated from the following files:

- time_slice.h
- tslice_adm_mass.C
- tslice_dirac_max.C
- tslice_dirac_max_evolve.C
- tslice_dirac_max_setAB.C
- tslice_dirac_max_solve.C